<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer.html">
<link rel="import" href="../bower_components/paper-fab/paper-fab.html">
<link rel="import" href="../bower_components/iron-icons/social-icons.html">
<link rel="import" href="../bower_components/iron-icons/iron-icons.html">
<link rel="import" href="shared-styles.html">
<link rel="import" href="chat-message.html">
<link rel="import" href="chat-service.html">

<dom-module id="chat-view">
  <template>
    <style include="shared-styles">
      :host {
        display: block;

        padding: 10px;
      }
    </style>
    <div class="card">
      <h1>{{chatName}}</h1>
      <template id="tasks" is="dom-repeat" items="{{messages}}">
        <!--<p>{{item.user}}:{{item.text}}:{{item.date}}</p>-->
        <chat-message username="{{_customUsername(item.user, username)}}" message="{{item.text}}" date="{{item.date}}"></chat-message>
      </template>
      <div class="send-message" layout horizontal>
        <paper-input flex label="Type message..." id="input" value="{{message}}"></paper-input>
        <paper-fab icon="icons:send" id="sendButton" on-tap="_sendMessage"></paper-fab>
      </div>
      <chat-service id="messageManager" messages="{{messages}}" username="{{username}}" chat-channel="[[chatChannel]]"></chat-service>
    </div>
  </template>

  <script>
    Polymer({
      is: 'chat-view',
      properties: {
        messages: {
          type: Array,
          value: []
        },
        message: {
          type: String,
          notify: true
        },
        username : {
          type: String,
          notify: true
        },
        chatName : {
          type: String
        },
        chatChannel : {
          type: String
        }
      },
      _sendMessage: function() {
            this.$.messageManager.sendMessage(this.message);
       },
      _customUsername : function(name, username) {
          console.log(name);
          if (name === username) {
              return "You";
          } else {
              return name;
          }
      }
    });
    function randID(){  // RandID is just a large number, could be better.
        return Math.floor(Math.random()*10000);
    }
  </script>
</dom-module>
